=== debian/changelog ===
ctre (3.9.0+ds-2) unstable; urgency=medium

  * Source-only upload to allow migration.
  * d/control:
    + bump std-ver to 4.7.2 (no changes required).
    + do not build libctre-doc under profile nodoc.

 -- Shengqi Chen <harry@debian.org>  Sun, 09 Mar 2025 17:28:14 +0800

ctre (3.9.0+ds-1) unstable; urgency=medium

  * Initial packaging for ctre 3.9.0+ds (closes: #1095833).

 -- Shengqi Chen <harry@debian.org>  Tue, 25 Feb 2025 15:44:21 +0800
