=== debian/control ===
Source: ctre
Section: utils
Priority: optional
Standards-Version: 4.7.2
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
Homepage: https://github.com/hanickadot/compile-time-regular-expressions
Vcs-Git: https://salsa.debian.org/harry/ctre.git
Vcs-Browser: https://salsa.debian.org/harry/ctre
Rules-Requires-Root: no

Package: libctre-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Description: Compile Time Regular Expression library in C++ (development files)
 ctre is a fast compile-time regular expressions C++ library with support
 for matching/searching/capturing during compile-time or runtime.
 .
 This package contains the development files of libctre.

Package: libctre-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Compile Time Regular Expression library in C++ (documentation)
 ctre is a fast compile-time regular expressions C++ library with support
 for matching/searching/capturing during compile-time or runtime.
 .
 This package contains the documentation of libctre.
