=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds//g,\
  filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/hanickadot/compile-time-regular-expressions/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
