## ctre 3.10.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
 Package: libctre-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Compile Time Regular Expression library in C++ (development files)
  ctre is a fast compile-time regular expressions C++ library with support
@@ -28,6 +29,7 @@
 Build-Profiles: <!nodoc>
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: Compile Time Regular Expression library in C++ (documentation)
  ctre is a fast compile-time regular expressions C++ library with support
