=== debian/changelog ===
ctre (3.10.0+ds-1) unstable; urgency=medium

  * New upstream version 3.10.0+ds.
  * d/rules: install arch-indep cmake and pkgconf files into /usr/share.

 -- Shengqi Chen <harry@debian.org>  Thu, 14 Aug 2025 23:17:23 +0800

ctre (3.9.0+ds-3) unstable; urgency=medium

  * d/control: mark Multi-Arch: foreign for libctre-{dev,doc}.

 -- Shengqi Chen <harry@debian.org>  Tue, 11 Mar 2025 20:14:26 +0800
