=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,8 @@
 	dh $@ --with=sphinxdoc --buildsystem=cmake+ninja --builddir=build
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCTRE_BUILD_TESTS=ON
+	dh_auto_configure -- -DCTRE_BUILD_TESTS=ON \
+		-DCMAKE_INSTALL_LIBDIR=/usr/share # these are all arch-indep files, so do not put them into /usr/lib/$triplet
 
 override_dh_installdocs:
 	dh_installdocs
